package com.myoa.engineering.crawl.shopping.configuration.feign;

import feign.RequestInterceptor;
import io.github.resilience4j.circuitbreaker.annotation.CircuitBreaker;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class FmkoreaClientFeignConfiguration {

    @Bean
    public RequestInterceptor requestInterceptor() {
        // TODO ignore 4xx
        return requestTemplate -> new FakeUserAgentInterceptor().apply(requestTemplate);
    }

/*
    @Bean
    public FmkoreaBoardClient fmkoreaBoardClient(RateLimiterRegistry rateLimiterRegistry,
                                                 CircuitBreakerRegistry circuitBreakerRegistry,
                                                 RequestInterceptor requestInterceptor) {
        FeignDecorators decorators = FeignDecorators.builder()
                                                    .withCircuitBreaker(circuitBreakerRegistry.circuitBreaker("rateLimit"))
                                                    .withRateLimiter(rateLimiterRegistry.rateLimiter("rateLimit"))
                                                    .build();

        return Resilience4jFeign.builder(decorators)
                                .requestInterceptor(requestInterceptor)
                                .target(FmkoreaBoardClient.class, "https://www.fmkorea.com");
    }
*/


}

